require 'optparse'
require 'ostruct'

module Urltest
  module Commands
    class Options
      attr_reader :options

      def initialize(args)
        @options = OpenStruct.new
        @options.times = 10

        opts = OptionParser.new do |opts|
          opts.banner = "\nSpeed test for your url(api)\n\nUsage: urltest [options]"
          opts.version = Urltest::VERSION

          opts.separator ''
          opts.separator 'Optional:'

          opts.on_head('-t', '--times [N]', Integer, 'Request times') do |t|
            @options.times = t || 10
          end
          opts.on_head('-l', '--link [URL]', String, 'URL link') do |l|
            @options.link = l
          end

          opts.on('--version', "Show version") do |v|
            puts opts.version
            exit
          end

          opts.on('--help', "Show help") do |v|
            puts opts
            exit
          end
        end

        opts.parse!(args)
      end

      def parse
        @options
      end
    end
  end
end
